#!/uns/bin/perl -w
# Typical usage:  average-cums.pl *.frequse_cum

# For order of appearance in tables, do this:
# $macros/scripts/average-cums.pl cat-null_define.freqdef_cum cat-constant.freqdef_cum cat-expression.freqdef_cum cat-statement.freqdef_cum cat-type.freqdef_cum cat-mismatched_entities.freqdef_cum cat-reserved_word.freqdef_cum cat-unknown_symbol.freqdef_cum cat-command_line_arguments.freqdef_cum cat-uncategorized.freqdef_cum
# $macros/scripts/average-cums.pl cat-null_define.freqddf_cum cat-constant.freqddf_cum cat-expression.freqddf_cum cat-statement.freqddf_cum cat-type.freqddf_cum cat-mismatched_entities.freqddf_cum cat-reserved_word.freqddf_cum cat-unknown_symbol.freqddf_cum cat-command_line_arguments.freqddf_cum cat-uncategorized.freqddf_cum
# $macros/scripts/average-cums.pl cat-null_define.frequse_cum cat-constant.frequse_cum cat-expression.frequse_cum cat-statement.frequse_cum cat-type.frequse_cum cat-mismatched_entities.frequse_cum cat-reserved_word.frequse_cum cat-unknown_symbol.frequse_cum cat-command_line_arguments.frequse_cum cat-uncategorized.frequse_cum

use English;
use File::Basename;
use Carp;
$fDebug = 0;

my $script_name = basename($0);

if ($#ARGV == -1) {
  usage();
}

@files = @ARGV;

sub usage {
  print STDERR "Usage: $script_name <*.freq{use,def,ddf}_cum files>\n";
  exit -1;
}

$OFS = "\t";

my $grand_weighted = 0;
my $grand_total = 0;
my $file;
foreach $file (@files) {
  if ($file !~ /^(?:cat-)?(.*)\.freq(...)_cum$/)
    { die "What file? $file"; }
  my $pkg = $1;
  my $type = $2;

  print STDERR "Reading $file...\n" if $fDebug;
  open(IN,"<$file") or die "Can't open $file: $!";
  $_ = <IN>;
  if (!/^Total	(\d+)\s*$/)
    { die "Didn't find total line first: $_"; }
  my $total = $1;
  $grand_total += $total;
  # print "Got total $total\n";

  my $weighted = 0;
  my $prev_num = 0;
  my $line;
  while (defined($line = <IN>) && ($line ne "\n")) {
    my ($bucket, $num) = split(/\s+/, $line);
    my $difference = $num - $prev_num;
    $prev_num = $num;
    # print "d $difference b $bucket\n";
    $weighted += $difference * $bucket;
    # print $bucket, $weighted, "\n";
  }
  $grand_weighted += $weighted;
  # print $weighted, $total;
  print $pkg, $type, sprintf("%.1f",$weighted/$total), "\n";

  close(IN);
}
print "Overall: $grand_weighted $grand_total\n";
print "Overall", sprintf("%.1f",$grand_weighted/$grand_total), "\n";
