#!/uns/bin/perl

# Count noncomment, nonblank lines in a Perl script.
# Not exact, since blank lines in string literals are counted, and any
# "#" not preceded by a backslash is considered a comment starter.
# But probably good enough.

while (<>)
{ s/(^|[^\\])\#.*$//;
  if (!/^\s*$/)
    { $ncnb++; } }

END { print "$ncnb\n"; }

