;; Don't use this any more; it has been translated into Perl and
;; incorporated into em_reports.

;; grep '\bif\b' *.catg > ~/macros-with-if

;; eliminate library files
(defun eliminate-library-files ()
  (goto-char (point-min))
  (delete-matching-lines "^[a-z]+\\.catg:/"))

(defun strip-comments ()
  (goto-char (point-min))
  (replace-regexp "/\\*[^*]*\\*/" "")
  (goto-char (point-min))
  (replace-regexp "/\\*[^/]*\\*/" ""))

;; `prefix-regexp' precedes the body of the macro
(setq prefix-regexp "^[^ ]* [^:]*: [a-zA-Z0-9_]+\\(([^)]*)\\)?[ \t]+")

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

(eliminate-library-files)

(strip-comments)

;; Replace blocks by empty statements
(while (progn (goto-char (point-min))
	      (re-search-forward "{[^{}\n]+}" nil t))
  (goto-char (point-min))
  (replace-regexp "{[^{}\n]+}" ";" nil))
;; Remove macros that don't contain "if" any more
(goto-char (point-min))
(delete-non-matching-lines "[^_]\\bif\\b[^_]")

;; remove well-surrounded macro bodies
(goto-char (point-min))
(delete-matching-lines (concat prefix-regexp "do.*while (0)[ \t]*$"))

;; This shouldn't have any effect any more
;; ;; Give the benefit of the doubt if it both starts and ends with a brace.
;; ;; (delete-matching-lines (concat prefix-regexp "{[^\}\n]*}[ \t]*$"))
;; (delete-matching-lines (concat prefix-regexp "{.*}[ \t]*$"))

;; If last else isn't followed by if or brackets, remove the macro.
;; Here I only want to check the last else, not any preceding else
(progn
  (goto-char (point-max))
  (while (re-search-backward "\\belse\\b" nil t)
    (if (and (looking-at "[^{}\n]*$")
	     (not (looking-at ".*\\bif\\b")))
	(delete-region (progn (beginning-of-line) (point))
		       (progn (forward-line) (point)))
      (beginning-of-line))))

;; If next brace after if is a close brace, remove the macro.
;; Only want to do this for the first if (actually, the last toplevel if).
(progn
  (goto-char (point-min))
  (while (re-search-forward "\\bif\\b" nil t)
    (if (looking-at "[^{}\n]*}")
	(delete-region (progn (beginning-of-line) (point))
		       (progn (forward-line) (point)))
      (end-of-line))))

;; Now count everything without an else:

;; (occur "\\bif\\b[^{}]*}") isn't quite right, though, because I only want
;; to check for the first if (or rather, the last top-level if), not just
;; any if.

;; (let ((count 0))
;;   (goto-char (point-min))
;;   (while (re-search-forward "\\bif\\b" nil t)
;;     (if (not (looking-at ".*\\belse\\b"))
;; 	(progn
;; 	  (delete-region (progn (beginning-of-line) (point))
;; 			 (progn (forward-line) (point)))
;; 	  (setq count (1+ count)))
;;       (forward-line)))
;;   (message "Deleted %d bad macros" count))

;; (let ((count 0))
;;   (goto-char (point-min))
;;   (while (re-search-forward "\\bif\\b" nil t)
;;     (if (not (looking-at ".*\\belse\\b"))
;; 	(progn
;; 	  (delete-region (progn (beginning-of-line) (point))
;; 			 (progn (forward-line) (point)))
;; 	  (setq count (1+ count)))
;;       (forward-line)))
;;   (message "Deleted %d bad macros" count))

;; This indicates that I had only two misclassifications at this point, both resulting from mismatched entities.
;; So I can just count the number of lines.
(let ((count 0))
  (goto-char (point-max))
  (while (re-search-backward "\\bif\\b" nil t)
    (if (not (looking-at ".*\\belse\\b"))
	(progn
	  (delete-region (progn (beginning-of-line) (point))
			 (progn (forward-line) (point)))
	  (setq count (1+ count)))
      (forward-line -1)))
  (message "Deleted %d bad macros" count))

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;; Version for "do { ... } while (0)"

;; egrep 'do.*while' *.catg > ~/macros-with-do-while

(eliminate-library-files)
(strip-comments)
;; Don't insist on {} in between the "do" and "while"
(delete-non-matching-lines (concat prefix-regexp "do.*while[ \t]*([ \t]*0[ \t]*)[ \t]*$"))
