
#include <string>	//	strcpy

#if defined (_WIN32)
#pragma warning(disable:4127)
#endif


using namespace std;

namespace FileUtilities {

#if defined __unix__	/* cppp replaced: elif */
const 	char	kPathFolderSeparator	=	'/';
#elif defined _WIN32
const	char	kPathFolderSeparator	=	'\\';
#else
#error
#endif

}



void InitFileUtils(void)
{
	if (!gFileSpec) {
		gFileSpec = new FileSpec();
#if defined (_WIN32)	/* cppp replaced: elif */
		TCHAR moduleFullPath[_MAX_PATH];
#ifdef _UNICODE
		*gFileSpec =  unicode::ConvertWideToByte(moduleFullPath);
#else
		*gFileSpec =  string(moduleFullPath);
#endif
#elif defined (__unix__)
		*gFileSpec =  string(get_current_dir_name());
#endif
//	fFileSpecInit = true;
	}
}

FileSpec GetEmbeddedFile(const char* name)
{
#if defined (_WIN32)	/* cppp replaced: elif */

	TCHAR moduleFullPath[_MAX_PATH];
#ifdef _UNICODE
	FileSpec moduleFileSpec =  unicode::ConvertWideToByte(moduleFullPath);
#else
	FileSpec moduleFileSpec =  string(moduleFullPath);
#endif

#elif defined (__unix__)
	char moduleFullPath[255];
	return spec;
#endif
	
}

void get_blof_location(FileSpec& spec)
{
	BR_X::BRX_printf("FileUtilities::get_blof_location - Do WIN stuff here %s\n", spec.FullPath().c_str());
	throwIfMOFSErr(MOFS_Err_NotImplemented, SSE_DIR_ENTRY::FSAPI_ErrorString(MOFS_Err_NotImplemented));
}

FILE* OpenStatusFile(char *filePath)
{
	MOFS_ErrorNumber	err;
	struct tm*	cur_time;


	time_t		clocks;
	time(&clocks);
	fprintf(statusFile, "Sonic Movie Controller %d/%d/%d %d:%d:%d\n",
			cur_time->tm_mon, cur_time->tm_mday, cur_time->tm_year+1900,
			cur_time->tm_hour, cur_time->tm_min, cur_time->tm_sec);
	fflush(statusFile);
	
	return statusFile;
}


string GetSoftwareVersion(SInt16 versionID)
{
#if defined __unix__	/* cppp replaced: elif */
	return "";
#else
	return "";
#endif
}

FileSpec GetTempDirectory( void )
{

#if defined (_WIN32)
	string MBCSstring;
#ifdef _UNICODE
	MBCSstring = unicode::ConvertWideToByte(name.get());
#else
	MBCSstring =string(name.get());
#endif
	return FileSpec(MBCSstring);

#elif defined __unix__
	return FileSpec("/var/tmp/Sonic");
#endif
}

UInt32 FindFilesInDirectory( const std::string& rootName, const std::string& fileMask, std::vector< std::string >& fileList )
{
	UInt32 fileCount = 0;

#if defined (_WIN32)
	std::string fullName( ::AddPathComponent( rootName, fileMask ) );
#ifdef _UNICODE
	HANDLE hFileList = FindFirstFile(unicode::ConvertByteToWide(fullName).c_str(), &findFileData);
#else
	HANDLE hFileList = FindFirstFile(fullName.c_str(), &findFileData);
#endif
	++fileCount;
#ifdef _UNICODE
	fileList.push_back( unicode::ConvertWideToByte(findFileData.cFileName ) );
#else
	fileList.push_back( std::string( findFileData.cFileName ) );
#endif
	while( FindNextFile( hFileList, &findFileData ) )
	{
		++fileCount;
#ifdef _UNICODE
		fileList.push_back( unicode::ConvertWideToByte( findFileData.cFileName ) );
#else
		fileList.push_back( std::string( findFileData.cFileName ) );
#endif
	}

#else
	printf("FindFilesInDirectory - Implement for Unknown platform\n");
#endif
	return( fileCount );
}


