#!/usr/bin/env perl
# Create file "test-elif.c"
# Run like this:  make-test-elif.pl > test-elif.c

use strict;
use English;
$WARNING = 1;

my $true = 1;
my $false = 0;

my $tvar = "TRUE";
my $fvar = "FALSE";
my $uvar = "UNKNOWN";


# number of nested "#if"
my $max_depth = 3;
# number of "#elif" (
my $num_elif = 2;
# include "#else"?
my $has_else = $true;
# $has_else = $false;

my $lineno = 1;


print "/* To test this file, see script test-cppp-elif */\n";
print "/* This file was constructed by script make-test-elif.pl */\n";

print_numbered_line();
one_level(0);
print "/* End of file */\n";
exit($false);



sub new_stack ( $ ) {
  my ($size) = @_;
  my @result = ($tvar) x $size;
  return @result;
}

sub increment_stack ( @ ) {
  my @stack = @_;
  # find element to increment
  my $i = $#stack;
  while (($i >= 0) && ($stack[$i] eq $uvar)) {
    $i--;
  }
  # $i is element to increment.
  if ($i == -1) {
    $stack[0] = undef;
    return @stack;
  }
  if ($stack[$i] eq $tvar) {
    $stack[$i] = $fvar;
  } elsif ($stack[$i] eq $fvar) {
    $stack[$i] = $uvar;
  } else {
    die "Bad stack element stack[$i]=\"$stack[$i]\": @stack";
  }
  $i++;
  while ($i < scalar(@stack)) {
    $stack[$i] = $tvar;
    $i++;
  }
  return @stack;
}

sub print_numbered_line () {
  print "$lineno\n";
  $lineno++;
}

sub one_level ( $ ) {
  my ($d) = @_;

  if ($d >= $max_depth) {
    return;
  }

  my @stack = new_stack($num_elif+1);
  do {
    print_one_level($d, @stack);
    @stack = increment_stack(@stack);
  } while (defined($stack[0]));

}

sub print_one_level ( $@ ) {
  my ($d, @stack) = @_;

  my $indent = "#" . (" " x ($d * 2));
  print  "${indent}if ($stack[0])\n";
  print_numbered_line();
  one_level($d+1);
  for (my $i=1; $i<scalar(@stack); $i++) {
    print "${indent}elif ($stack[$i])\n";
    print_numbered_line();
    one_level($d+1);
  }
  if ($has_else) {
    print "${indent}else\n";
    print_numbered_line();
    one_level($d+1);
  }
  print "${indent}endif\n";
  print_numbered_line();
}
