
#include <cctype>			// for toupper()
#include <cstdio>
#include <cstdlib>
#include <string>

#include "sse_server.h"

#ifdef _WIN32
#include "Win_IOCTL.h"
#endif


#ifdef	__unix__
#include "ix_local_server.h"
#endif	// __unix__

using namespace std;

static BASE_SERVER* getNewServer(COMMON_SERVER::SERVER_TYPE t, const COMMON_SERVER::ServerID_t* /*id*/)
{
	BASE_SERVER* server_ptr = NULL;

	if (t == COMMON_SERVER::ST_SERVER_UNKNOWN)
	{
#ifdef _WIN32
		if (WinIOCTL::IsWindowsNT())
			t = COMMON_SERVER::ST_NT_LOCAL;
		else
			t = COMMON_SERVER::ST_WIN98_LOCAL;
#elif defined __unix__
		t = COMMON_SERVER::ST_IX_LOCAL;
#endif
	}

	{
		server_ptr = SSE_Server_Table::Get( t );
	}

	if (server_ptr)
		server_ptr->incAccessors();

	return server_ptr;
}
